# Generated by Django 4.0 on 2022-01-15 22:51
from decimal import Decimal

from django.db import migrations, models


def merge_budget_receivers(apps, schema_editor):
    # We get the model from the versioned app registry;
    # if we directly import it, it'll be the wrong version
    BudgetReceiver = apps.get_model("core", "BudgetReceiver")
    EventBudgetReceiver = apps.get_model("core", "EventBudgetReceiver")

    db_alias = schema_editor.connection.alias
    for obj in BudgetReceiver.objects.using(db_alias).all():
        obj.planned = Decimal(0) - (obj.budget or Decimal(0))
        obj.save()
    for obj in EventBudgetReceiver.objects.using(db_alias).all():
        b = BudgetReceiver(receiver=obj.receiver, anual_plan=obj.anual_plan, planned=obj.planned_result)
        b.save()
        obj.delete()


def split_budget_receivers(apps, schema_editor):
    # We get the model from the versioned app registry;
    # if we directly import it, it'll be the wrong version
    BudgetReceiver = apps.get_model("core", "BudgetReceiver")
    EventBudgetReceiver = apps.get_model("core", "EventBudgetReceiver")

    db_alias = schema_editor.connection.alias
    for obj in BudgetReceiver.objects.using(db_alias).filter(receiver__fond__name="Veranstaltungsfond"):
        EventBudgetReceiver(receiver=obj.receiver, anual_plan=obj.anual_plan, planned_result=obj.planned).save()
        obj.delete()
    for obj in BudgetReceiver.objects.using(db_alias).filter(receiver__fond__name="Haushaltsfond"):
        obj.budget = Decimal(0) - obj.planned
        obj.planned_budget = obj.budget
        obj.save()


class Migration(migrations.Migration):

    dependencies = [
        ("core", "0102_alter_budgetreceiver_options_and_more"),
    ]

    operations = [
        migrations.AddField(
            model_name="budgetreceiver",
            name="planned",
            field=models.DecimalField(decimal_places=2, default=0, max_digits=21, verbose_name="Geplanter Saldo"),
            preserve_default=False,
        ),
        migrations.RemoveField(
            model_name="budgetreceiver",
            name="fachschaft",
        ),
        migrations.RunPython(code=merge_budget_receivers, reverse_code=split_budget_receivers),
        migrations.RemoveField(
            model_name="budgetreceiver",
            name="planned_budget",
        ),
        migrations.RemoveField(
            model_name="budgetreceiver",
            name="student_count",
        ),
        migrations.RemoveField(model_name="budgetreceiver", name="budget"),
        migrations.DeleteModel(
            name="EventBudgetReceiver",
        ),
    ]
